!SURFEX_LIC Copyright 1994-2014 Meteo-France 
!SURFEX_LIC This is part of the SURFEX software governed by the CeCILL-C  licence
!SURFEX_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt
!SURFEX_LIC for details. version 1.
!     ##################
      MODULE MODD_IO_BUFF_n
!     ##################
!
!!****  *MODD_IO_IO_BUFF - 
!!
!!    PURPOSE
!!    -------
!
!!
!!**  IMPLICIT ARGUMENTS
!!    ------------------
!!      None 
!!
!!    REFERENCE
!!    ---------
!!
!!    AUTHOR
!!    ------
!!	V. Masson    *Meteo France*
!!
!!    MODIFICATIONS
!!    -------------
!!    
!
!*       0.   DECLARATIONS
!
!!      
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE PARKIND1  ,ONLY : JPRB
!
IMPLICIT NONE

TYPE IO_BUFF_t

 CHARACTER(LEN=12), DIMENSION(3000) :: CREC   ! list of records already read/written
INTEGER                            :: NREC   ! number of records read/written

END TYPE IO_BUFF_t
!
TYPE(IO_BUFF_t), ALLOCATABLE, TARGET, SAVE :: IO_BUFF_MODEL(:)
!
 CHARACTER(LEN=12), DIMENSION(:),    POINTER :: CREC=> NULL()
INTEGER,                            POINTER :: NREC=> NULL()
!
CONTAINS
SUBROUTINE IO_BUFF_GOTO_MODEL(KFROM, KTO, LKFROM)
LOGICAL, INTENT(IN) :: LKFROM
INTEGER, INTENT(IN) :: KFROM, KTO
REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK('MODD_IO_BUFF_N:IO_BUFF_GOTO_MODEL',0,ZHOOK_HANDLE)
CREC=>IO_BUFF_MODEL(KTO)%CREC
NREC=>IO_BUFF_MODEL(KTO)%NREC
IF (LHOOK) CALL DR_HOOK('MODD_IO_BUFF_N:IO_BUFF_GOTO_MODEL',1,ZHOOK_HANDLE)
!
END SUBROUTINE IO_BUFF_GOTO_MODEL

SUBROUTINE IO_BUFF_ALLOC(KMODEL)
INTEGER, INTENT(IN) :: KMODEL
REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK("MODD_IO_BUFF_N:IO_BUFF_ALLOC",0,ZHOOK_HANDLE)
ALLOCATE(IO_BUFF_MODEL(KMODEL))
IO_BUFF_MODEL(:)%NREC=0
IF (LHOOK) CALL DR_HOOK("MODD_IO_BUFF_N:IO_BUFF_ALLOC",1,ZHOOK_HANDLE)
END SUBROUTINE IO_BUFF_ALLOC

SUBROUTINE IO_BUFF_DEALLO
REAL(KIND=JPRB) :: ZHOOK_HANDLE
IF (LHOOK) CALL DR_HOOK("MODD_IO_BUFF_N:IO_BUFF_DEALLO",0,ZHOOK_HANDLE)
IF (ALLOCATED(IO_BUFF_MODEL)) DEALLOCATE(IO_BUFF_MODEL)
IF (LHOOK) CALL DR_HOOK("MODD_IO_BUFF_N:IO_BUFF_DEALLO",1,ZHOOK_HANDLE)
END SUBROUTINE IO_BUFF_DEALLO
!
END MODULE MODD_IO_BUFF_n
