!SURFEX_LIC Copyright 1994-2014 Meteo-France 
!SURFEX_LIC This is part of the SURFEX software governed by the CeCILL-C  licence
!SURFEX_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt
!SURFEX_LIC for details. version 1.
MODULE MODE_MODELN_SURFEX_HANDLER
!
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE PARKIND1  ,ONLY : JPRB
!
IMPLICIT NONE 

INTEGER, SAVE, PRIVATE :: ICURRENT_MODEL = -1
!$OMP THREADPRIVATE(ICURRENT_MODEL)

CONTAINS 

FUNCTION GET_CURRENT_MODEL_INDEX_SURFEX()
INTEGER :: GET_CURRENT_MODEL_INDEX_SURFEX
REAL(KIND=JPRB) :: ZHOOK_HANDLE
!!
IF (LHOOK) CALL DR_HOOK('MODE_MODELN_SURFEX_HANDLER:GET_CURRENT_MODEL_INDEX_SURFEX',0,ZHOOK_HANDLE)
GET_CURRENT_MODEL_INDEX_SURFEX = ICURRENT_MODEL
IF (LHOOK) CALL DR_HOOK('MODE_MODELN_SURFEX_HANDLER:GET_CURRENT_MODEL_INDEX_SURFEX',1,ZHOOK_HANDLE)
!!
END FUNCTION GET_CURRENT_MODEL_INDEX_SURFEX

SUBROUTINE GOTO_MODEL_SURFEX(KMI, LKFROM)
!
USE MODI_GOTO_WRAPPER_FLAKE
USE MODI_GOTO_WRAPPER_IDEAL
USE MODI_GOTO_WRAPPER_ISBA
USE MODI_GOTO_WRAPPER_OCEAN
USE MODI_GOTO_WRAPPER_SEAFLUX
USE MODI_GOTO_WRAPPER_SURFATM
USE MODI_GOTO_WRAPPER_TEB
USE MODI_GOTO_WRAPPER_WATFLUX
!
LOGICAL, INTENT(IN) :: LKFROM
INTEGER, INTENT(IN) :: KMI
REAL(KIND=JPRB) :: ZHOOK_HANDLE
!!
IF (LHOOK) CALL DR_HOOK('MODE_MODELN_SURFEX_HANDLER:GOTO_MODEL_SURFEX',0,ZHOOK_HANDLE)

IF (LKFROM) THEN

  IF (ICURRENT_MODEL == -1) THEN
  ! First call to GOTO_MODEL_SURFEX
    ICURRENT_MODEL = 1 ! Default model index
    CALL GOTO_WRAPPER_SURFATM(ICURRENT_MODEL, KMI, LKFROM)
  !
    CALL GOTO_WRAPPER_ISBA   (ICURRENT_MODEL, KMI, LKFROM)
    CALL GOTO_WRAPPER_TEB    (ICURRENT_MODEL, KMI, LKFROM, 1)
    CALL GOTO_WRAPPER_SEAFLUX(ICURRENT_MODEL, KMI, LKFROM)
    CALL GOTO_WRAPPER_IDEAL  (ICURRENT_MODEL, KMI, LKFROM)
    CALL GOTO_WRAPPER_OCEAN  (ICURRENT_MODEL, KMI, LKFROM)
    CALL GOTO_WRAPPER_WATFLUX(ICURRENT_MODEL, KMI, LKFROM)
    CALL GOTO_WRAPPER_FLAKE  (ICURRENT_MODEL, KMI, LKFROM)
    ICURRENT_MODEL = KMI
  ELSE

    CALL GOTO_WRAPPER_SURFATM(ICURRENT_MODEL, KMI, LKFROM)
  !
    CALL GOTO_WRAPPER_ISBA   (ICURRENT_MODEL, KMI, LKFROM)
    CALL GOTO_WRAPPER_TEB    (ICURRENT_MODEL, KMI, LKFROM, 1)
    CALL GOTO_WRAPPER_SEAFLUX(ICURRENT_MODEL, KMI, LKFROM)
    CALL GOTO_WRAPPER_IDEAL  (ICURRENT_MODEL, KMI, LKFROM)
    CALL GOTO_WRAPPER_OCEAN  (ICURRENT_MODEL, KMI, LKFROM)
    CALL GOTO_WRAPPER_WATFLUX(ICURRENT_MODEL, KMI, LKFROM)
    CALL GOTO_WRAPPER_FLAKE  (ICURRENT_MODEL, KMI, LKFROM)
    ICURRENT_MODEL = KMI 

  END IF

ELSE

    CALL GOTO_WRAPPER_SURFATM(ICURRENT_MODEL, KMI, LKFROM)
  !
    CALL GOTO_WRAPPER_ISBA   (ICURRENT_MODEL, KMI, LKFROM)
    CALL GOTO_WRAPPER_TEB    (ICURRENT_MODEL, KMI, LKFROM, 1)
    CALL GOTO_WRAPPER_SEAFLUX(ICURRENT_MODEL, KMI, LKFROM)
    CALL GOTO_WRAPPER_IDEAL  (ICURRENT_MODEL, KMI, LKFROM)
    CALL GOTO_WRAPPER_OCEAN  (ICURRENT_MODEL, KMI, LKFROM)
    CALL GOTO_WRAPPER_WATFLUX(ICURRENT_MODEL, KMI, LKFROM)
    CALL GOTO_WRAPPER_FLAKE  (ICURRENT_MODEL, KMI, LKFROM)

    ICURRENT_MODEL = KMI


ENDIF

IF (LHOOK) CALL DR_HOOK('MODE_MODELN_SURFEX_HANDLER:GOTO_MODEL_SURFEX',1,ZHOOK_HANDLE)
!!
END SUBROUTINE GOTO_MODEL_SURFEX

END MODULE MODE_MODELN_SURFEX_HANDLER

