!SURFEX_LIC Copyright 1994-2014 Meteo-France 
!SURFEX_LIC This is part of the SURFEX software governed by the CeCILL-C  licence
!SURFEX_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt
!SURFEX_LIC for details. version 1.
SUBROUTINE READ_FROM_SURFEX_FILE(HFTYP,HFNAM,HMASK,HSCHEME,PFIELD,HNAM)
!
USE MODI_INIT_IO_SURF_n
USE MODI_END_IO_SURF_n
USE MODI_READ_SURF
!
#ifdef ASC
USE MODI_SET_SURFEX_FILE_NAME_ASC
#endif
#ifdef FA
USE MODI_SET_SURFEX_FILE_NAME_FA
#endif
#ifdef LFI
USE MODI_SET_SURFEX_FILE_NAME_LFI
#endif
!
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE PARKIND1  ,ONLY : JPRB
!
IMPLICIT NONE
!
 CHARACTER(LEN=6), INTENT(IN) :: HFTYP
 CHARACTER(LEN=28), INTENT(IN) :: HFNAM
 CHARACTER(LEN=6), INTENT(IN) :: HMASK
 CHARACTER(LEN=6), INTENT(IN) :: HSCHEME
REAL, DIMENSION(:), INTENT(OUT) :: PFIELD
 CHARACTER(LEN=*), OPTIONAL, INTENT(IN) :: HNAM
!
 CHARACTER(LEN=28)     :: HNAME
 CHARACTER(LEN=12)     :: YRECFM
INTEGER               :: IRESP, I0
!
REAL(KIND=JPRB) :: ZHOOK_HANDLE

IF (LHOOK) CALL DR_HOOK('READ_FROM_SURFEX_FILE',0,ZHOOK_HANDLE)

HNAME=ADJUSTL(ADJUSTR(HFNAM))

IF (PRESENT(HNAM)) THEN
  YRECFM=HNAM
ELSE
  I0=INDEX(HNAME,'.',BACK=.TRUE.)
  YRECFM=HNAME(1:I0-1)
ENDIF

IF (HFTYP=='ASCII ') THEN
#ifdef ASC
  CALL SET_SURFEX_FILE_NAME_ASC(HNAME_IN=HNAME)
#endif
ELSEIF (HFTYP=='FA    ') THEN
#ifdef FA
  CALL SET_SURFEX_FILE_NAME_FA(HNAME_IN=HNAME)
#endif
ELSEIF (HFTYP=='LFI   ') THEN
#ifdef LFI
  CALL SET_SURFEX_FILE_NAME_LFI(HNAME_IN=HNAME)
#endif
ENDIF

 CALL INIT_IO_SURF_n(HFTYP,HMASK,HSCHEME,'READ ')
 CALL READ_SURF(HFTYP,YRECFM,PFIELD,IRESP)
 CALL END_IO_SURF_n(HFTYP)

IF (LHOOK) CALL DR_HOOK('READ_FROM_SURFEX_FILE',1,ZHOOK_HANDLE)

END SUBROUTINE READ_FROM_SURFEX_FILE
