!SURFEX_LIC Copyright 1994-2014 Meteo-France 
!SURFEX_LIC This is part of the SURFEX software governed by the CeCILL-C  licence
!SURFEX_LIC version 1. See LICENSE, CeCILL-C_V1-en.txt and CeCILL-C_V1-fr.txt
!SURFEX_LIC for details. version 1.
!     #########
      SUBROUTINE READ_PGD_TEB_PAR_n(HPROGRAM,KNI,HDIRIN)
!     ################################################
!
!!****  *READ_PGD_TEB_PAR_n* - reads ISBA physiographic fields
!!                        
!!
!!    PURPOSE
!!    -------
!!
!!**  METHOD
!!    ------
!!
!!    EXTERNAL
!!    --------
!!
!!
!!    IMPLICIT ARGUMENTS
!!    ------------------
!!
!!    REFERENCE
!!    ---------
!!
!!
!!    AUTHOR
!!    ------
!!	V. Masson   *Meteo France*	
!!
!!    MODIFICATIONS
!!    -------------
!!      Original    05/2005
!-------------------------------------------------------------------------------
!
!*       0.    DECLARATIONS
!              ------------
!
USE MODD_TEB_GRID_n, ONLY :   NDIM
USE MODD_TEB_n,      ONLY :   LECOCLIMAP, LGARDEN, CBEM
USE MODD_DATA_TEB_n, ONLY :   NPAR_ROOF_LAYER, NPAR_WALL_LAYER, NPAR_ROAD_LAYER, &
                              NPAR_BLDTYPE, NPAR_USETYPE,                        &
                              NPAR_BLDCODE, NPAR_BLD_AGE,                        &
                              XPAR_Z0_TOWN, XPAR_BLD,                            &
                              XPAR_GARDEN, XPAR_ROAD_DIR, XPAR_GREENROOF,        &
                              XPAR_ALB_ROOF,                                     &
                              XPAR_EMIS_ROOF, XPAR_HC_ROOF, XPAR_TC_ROOF,        &
                              XPAR_D_ROOF, XPAR_ALB_ROAD, XPAR_EMIS_ROAD,        &
                              XPAR_HC_ROAD, XPAR_TC_ROAD, XPAR_D_ROAD,           &
                              XPAR_ALB_WALL, XPAR_EMIS_WALL, XPAR_HC_WALL,       &
                              XPAR_TC_WALL, XPAR_D_WALL, XPAR_BLD_HEIGHT,        &
                              XPAR_WALL_O_HOR,                                   &
                              XPAR_H_TRAFFIC, XPAR_LE_TRAFFIC,                   &
                              XPAR_H_INDUSTRY, XPAR_LE_INDUSTRY,                 &
                              LDATA_Z0_TOWN, LDATA_BLD, LDATA_ALB_ROOF,          &
                              LDATA_EMIS_ROOF, LDATA_HC_ROOF, LDATA_TC_ROOF,     &
                              LDATA_D_ROOF, LDATA_ALB_ROAD, LDATA_EMIS_ROAD,     &
                              LDATA_HC_ROAD, LDATA_TC_ROAD, LDATA_D_ROAD,        &
                              LDATA_ALB_WALL, LDATA_EMIS_WALL, LDATA_HC_WALL,    &
                              LDATA_TC_WALL, LDATA_D_WALL, LDATA_BLD_HEIGHT,     &
                              LDATA_WALL_O_HOR,                                  &
                              LDATA_H_TRAFFIC, LDATA_LE_TRAFFIC,                 &
                              LDATA_H_INDUSTRY, LDATA_LE_INDUSTRY ,              &
                              LDATA_GARDEN, LDATA_BLDTYPE, LDATA_GREENROOF,      &
                              LDATA_ROAD_DIR, LDATA_USETYPE, LDATA_BLD_AGE,      &
                              LDATA_ROUGH_ROOF, LDATA_ROUGH_WALL,                &
                              XPAR_ROUGH_WALL, XPAR_ROUGH_ROOF

USE MODD_DATA_BEM_n, ONLY :   NPAR_FLOOR_LAYER,                                  &
                              XPAR_TCOOL_TARGET, XPAR_THEAT_TARGET,              &
                              XPAR_HC_FLOOR, XPAR_TC_FLOOR, XPAR_D_FLOOR,        & 
                              XPAR_F_WASTE_CAN, XPAR_SHADE, XPAR_NATVENT,        &
                              XPAR_EFF_HEAT, XPAR_QIN, XPAR_QIN_FRAD,            &
                              XPAR_SHGC, XPAR_U_WIN, XPAR_GR,                    &
                              XPAR_FLOOR_HEIGHT, XPAR_INF, XPAR_QIN_FLAT,        &
                              XPAR_HR_TARGET, XPAR_V_VENT, XPAR_CAP_SYS_HEAT,    &
                              XPAR_CAP_SYS_RAT, XPAR_T_ADP, XPAR_M_SYS_RAT,      &
                              XPAR_COP_RAT, XPAR_T_SIZE_MAX, XPAR_T_SIZE_MIN,    &
                              XPAR_F_WATER_COND, XPAR_SHGC_SH,                   &
                              LDATA_HC_FLOOR, LDATA_TC_FLOOR, LDATA_D_FLOOR,     &
                              LDATA_TCOOL_TARGET, LDATA_THEAT_TARGET,            &
                              LDATA_F_WASTE_CAN, LDATA_SHADE, LDATA_NATVENT,     &
                              LDATA_EFF_HEAT, LDATA_QIN, LDATA_QIN_FRAD,         &
                              LDATA_SHGC, LDATA_U_WIN, LDATA_GR,                 &
                              LDATA_FLOOR_HEIGHT, LDATA_INF, LDATA_QIN_FLAT,     &
                              LDATA_HR_TARGET, LDATA_V_VENT, LDATA_CAP_SYS_HEAT, &
                              LDATA_CAP_SYS_RAT, LDATA_T_ADP, LDATA_M_SYS_RAT,   &
                              LDATA_COP_RAT, LDATA_T_SIZE_MAX, LDATA_T_SIZE_MIN, &
                              LDATA_F_WATER_COND, LDATA_SHGC_SH
!
USE MODI_READ_SURF
USE MODI_READ_BLD_DESCRIPTION
USE MODI_GET_LUOUT
USE MODI_BLDCODE
USE MODI_ABOR1_SFX
!
USE YOMHOOK   ,ONLY : LHOOK,   DR_HOOK
USE PARKIND1  ,ONLY : JPRB
!
IMPLICIT NONE
!
!*       0.1   Declarations of arguments
!              -------------------------
!
 CHARACTER(LEN=6),  INTENT(IN)  :: HPROGRAM ! program calling
INTEGER,           INTENT(IN)  :: KNI      ! size of the new domain
 CHARACTER(LEN=1),  INTENT(IN)  :: HDIRIN
!
!*       0.2   Declarations of local variables
!              -------------------------------
!
INTEGER           :: ILUOUT         ! output listing logical unit
INTEGER           :: IRESP          ! IRESP  : return-code if a problem appears
 CHARACTER(LEN=12) :: YRECFM         ! Name of the article to be read
INTEGER           :: JLAYER         ! loop index
!
INTEGER           :: IVERSION       ! surface version
INTEGER           :: IBUGFIX        ! surface bugfix version
REAL, DIMENSION(NDIM) :: ZWORK      ! work array
REAL(KIND=JPRB) :: ZHOOK_HANDLE
!
!-------------------------------------------------------------------------------
IF (LHOOK) CALL DR_HOOK('READ_PGD_TEB_PAR_N',0,ZHOOK_HANDLE)
!
 CALL GET_LUOUT(HPROGRAM,ILUOUT)
!
YRECFM='VERSION'
 CALL READ_SURF(HPROGRAM,YRECFM,IVERSION,IRESP)
YRECFM='BUG'
 CALL READ_SURF(HPROGRAM,YRECFM,IBUGFIX,IRESP)
!
IF (IVERSION<7 .AND. .NOT.LECOCLIMAP) THEN
  !
  LDATA_BLDTYPE     = .FALSE.
  LDATA_BLD_AGE     = .FALSE.
  LDATA_USETYPE     = .FALSE.
  LDATA_Z0_TOWN     = .TRUE.
  LDATA_BLD         = .TRUE.
  LDATA_GARDEN      = .TRUE.
  LDATA_GREENROOF   = .TRUE.
  LDATA_ROAD_DIR    = .FALSE.
  LDATA_ALB_ROOF    = .TRUE.
  LDATA_EMIS_ROOF   = .TRUE.
  LDATA_HC_ROOF     = .TRUE.
  LDATA_TC_ROOF     = .TRUE.
  LDATA_D_ROOF      = .TRUE.
  LDATA_ALB_ROAD    = .TRUE.
  LDATA_EMIS_ROAD   = .TRUE.
  LDATA_HC_ROAD     = .TRUE.
  LDATA_TC_ROAD     = .TRUE.
  LDATA_D_ROAD      = .TRUE.
  LDATA_ALB_WALL    = .TRUE.
  LDATA_EMIS_WALL   = .TRUE.
  LDATA_HC_WALL     = .TRUE.
  LDATA_TC_WALL     = .TRUE.
  LDATA_D_WALL      = .TRUE.
  LDATA_BLD_HEIGHT  = .TRUE.
  LDATA_WALL_O_HOR  = .TRUE.
  LDATA_H_TRAFFIC   = .TRUE.
  LDATA_LE_TRAFFIC  = .TRUE.
  LDATA_H_INDUSTRY  = .TRUE.
  LDATA_LE_INDUSTRY = .TRUE.
  LDATA_ROUGH_ROOF  = .FALSE.
  LDATA_ROUGH_WALL  = .FALSE.
  !
ELSEIF (IVERSION>=7) THEN
  !
  IF (IVERSION>7 .OR. IBUGFIX>=3) THEN
    YRECFM='L_BLDTYPE'
    CALL READ_SURF(HPROGRAM,YRECFM,LDATA_BLDTYPE,IRESP)
    YRECFM='L_BLD_AGE'
    CALL READ_SURF(HPROGRAM,YRECFM,LDATA_BLD_AGE,IRESP)
    YRECFM='L_USETYPE'
    CALL READ_SURF(HPROGRAM,YRECFM,LDATA_USETYPE,IRESP)
    IF (LDATA_BLDTYPE .OR. LDATA_BLD_AGE .OR. LDATA_USETYPE) CALL READ_BLD_DESCRIPTION(HPROGRAM)
  ENDIF
  YRECFM='L_Z0_TOWN'
  CALL READ_SURF(HPROGRAM,YRECFM,LDATA_Z0_TOWN,IRESP)
  YRECFM='L_BLD'
  CALL READ_SURF(HPROGRAM,YRECFM,LDATA_BLD,IRESP)
  IF (IVERSION>=6) THEN
    YRECFM='L_GARDEN'
    CALL READ_SURF(HPROGRAM,YRECFM,LDATA_GARDEN,IRESP)
  ENDIF
  IF (IVERSION==7 .AND. IBUGFIX<=2) THEN
    LDATA_ROAD_DIR = .FALSE.
    LDATA_GREENROOF= .FALSE.
  ELSE
    YRECFM='L_ROAD_DIR'
    CALL READ_SURF(HPROGRAM,YRECFM,LDATA_ROAD_DIR,IRESP)
    YRECFM='L_GREENROOF'
    CALL READ_SURF(HPROGRAM,YRECFM,LDATA_GREENROOF,IRESP)
  END IF
  YRECFM='L_ALB_ROOF'
  CALL READ_SURF(HPROGRAM,YRECFM,LDATA_ALB_ROOF,IRESP)
  YRECFM='L_EMIS_ROOF'
  CALL READ_SURF(HPROGRAM,YRECFM,LDATA_EMIS_ROOF,IRESP)
  YRECFM='L_HC_ROOF'
  CALL READ_SURF(HPROGRAM,YRECFM,LDATA_HC_ROOF,IRESP)
  YRECFM='L_TC_ROOF'
  CALL READ_SURF(HPROGRAM,YRECFM,LDATA_TC_ROOF,IRESP)
  YRECFM='L_D_ROOF'
  CALL READ_SURF(HPROGRAM,YRECFM,LDATA_D_ROOF,IRESP)
  YRECFM='L_ALB_ROAD'
  CALL READ_SURF(HPROGRAM,YRECFM,LDATA_ALB_ROAD,IRESP)
  YRECFM='L_EMIS_ROAD'
  CALL READ_SURF(HPROGRAM,YRECFM,LDATA_EMIS_ROAD,IRESP)
  YRECFM='L_HC_ROAD'
  CALL READ_SURF(HPROGRAM,YRECFM,LDATA_HC_ROAD,IRESP)
  YRECFM='L_TC_ROAD'
  CALL READ_SURF(HPROGRAM,YRECFM,LDATA_TC_ROAD,IRESP)
  YRECFM='L_D_ROAD'
  CALL READ_SURF(HPROGRAM,YRECFM,LDATA_D_ROAD,IRESP)
  YRECFM='L_ALB_WALL'
  CALL READ_SURF(HPROGRAM,YRECFM,LDATA_ALB_WALL,IRESP)
  YRECFM='L_EMIS_WALL'
  CALL READ_SURF(HPROGRAM,YRECFM,LDATA_EMIS_WALL,IRESP)
  YRECFM='L_HC_WALL'
  CALL READ_SURF(HPROGRAM,YRECFM,LDATA_HC_WALL,IRESP)
  YRECFM='L_TC_WALL'
  CALL READ_SURF(HPROGRAM,YRECFM,LDATA_TC_WALL,IRESP)
  YRECFM='L_D_WALL'
  CALL READ_SURF(HPROGRAM,YRECFM,LDATA_D_WALL,IRESP)
  YRECFM='L_BLD_HEIGHT'
  CALL READ_SURF(HPROGRAM,YRECFM,LDATA_BLD_HEIGHT,IRESP)
  YRECFM='L_WALL_O_HOR'
  CALL READ_SURF(HPROGRAM,YRECFM,LDATA_WALL_O_HOR,IRESP)
  YRECFM='L_H_TRAF'
  CALL READ_SURF(HPROGRAM,YRECFM,LDATA_H_TRAFFIC,IRESP)
  YRECFM='L_LE_TRAF'
  CALL READ_SURF(HPROGRAM,YRECFM,LDATA_LE_TRAFFIC,IRESP)
  YRECFM='L_H_IND'
  CALL READ_SURF(HPROGRAM,YRECFM,LDATA_H_INDUSTRY,IRESP)
  YRECFM='L_LE_IND'
  CALL READ_SURF(HPROGRAM,YRECFM,LDATA_LE_INDUSTRY,IRESP)
  IF (IVERSION>7 .OR. IBUGFIX>=3) THEN
    YRECFM='L_ROUGH_ROOF'
    CALL READ_SURF(HPROGRAM,YRECFM,LDATA_ROUGH_ROOF,IRESP)
    YRECFM='L_ROUGH_WALL'
    CALL READ_SURF(HPROGRAM,YRECFM,LDATA_ROUGH_WALL,IRESP)
  ENDIF
  !
  IF (CBEM=='BEM') THEN
    YRECFM='L_HC_FLOOR'
    CALL READ_SURF(HPROGRAM,YRECFM,LDATA_HC_FLOOR,IRESP)
    YRECFM='L_TC_FLOOR'
    CALL READ_SURF(HPROGRAM,YRECFM,LDATA_TC_FLOOR,IRESP)
    YRECFM='L_D_FLOOR'
    CALL READ_SURF(HPROGRAM,YRECFM,LDATA_D_FLOOR,IRESP)            
    YRECFM='L_TCOOL_TARG'
    CALL READ_SURF(HPROGRAM,YRECFM,LDATA_TCOOL_TARGET,IRESP)
    YRECFM='L_THEAT_TARG'
    CALL READ_SURF(HPROGRAM,YRECFM,LDATA_THEAT_TARGET,IRESP)
    YRECFM='L_F_WAST_CAN'
    CALL READ_SURF(HPROGRAM,YRECFM,LDATA_F_WASTE_CAN,IRESP)
    YRECFM='L_EFF_HEAT'
    CALL READ_SURF(HPROGRAM,YRECFM,LDATA_EFF_HEAT,IRESP)
    YRECFM='L_QIN'
    CALL READ_SURF(HPROGRAM,YRECFM,LDATA_QIN,IRESP)
    YRECFM='L_QIN_FRAD'
    CALL READ_SURF(HPROGRAM,YRECFM,LDATA_QIN_FRAD,IRESP)
    YRECFM='L_SHGC'
    CALL READ_SURF(HPROGRAM,YRECFM,LDATA_SHGC,IRESP)
    YRECFM='L_U_WIN'
    CALL READ_SURF(HPROGRAM,YRECFM,LDATA_U_WIN,IRESP)
    YRECFM='L_GR'
    CALL READ_SURF(HPROGRAM,YRECFM,LDATA_GR,IRESP)
    YRECFM='L_SHGC_SH'
    CALL READ_SURF(HPROGRAM,YRECFM,LDATA_SHGC_SH,IRESP)    
    YRECFM='L_FLOOR_HEIG'
    CALL READ_SURF(HPROGRAM,YRECFM,LDATA_FLOOR_HEIGHT,IRESP)
    YRECFM='L_INF'
    CALL READ_SURF(HPROGRAM,YRECFM,LDATA_INF,IRESP)
    YRECFM='L_FWAT_COND'
    CALL READ_SURF(HPROGRAM,YRECFM,LDATA_F_WATER_COND,IRESP)
    YRECFM='L_SHADE'
    CALL READ_SURF(HPROGRAM,YRECFM,LDATA_SHADE,IRESP) 
    YRECFM='L_NATVENT'
    CALL READ_SURF(HPROGRAM,YRECFM,LDATA_NATVENT,IRESP)     
    YRECFM='L_V_VENT'
    CALL READ_SURF(HPROGRAM,YRECFM,LDATA_V_VENT,IRESP)    
    YRECFM='L_QIN_FLAT'
    CALL READ_SURF(HPROGRAM,YRECFM,LDATA_QIN_FLAT,IRESP)
    YRECFM='L_HR_TARGET'
    CALL READ_SURF(HPROGRAM,YRECFM,LDATA_HR_TARGET,IRESP)
    YRECFM='L_CAP_SYS_HE'
    CALL READ_SURF(HPROGRAM,YRECFM,LDATA_CAP_SYS_HEAT,IRESP)
    YRECFM='L_CAP_SYS_RA'
    CALL READ_SURF(HPROGRAM,YRECFM,LDATA_CAP_SYS_RAT,IRESP)
    YRECFM='L_T_ADP'
    CALL READ_SURF(HPROGRAM,YRECFM,LDATA_T_ADP,IRESP)
    YRECFM='L_M_SYS_RAT'
    CALL READ_SURF(HPROGRAM,YRECFM,LDATA_M_SYS_RAT,IRESP)
    YRECFM='L_COP_RAT'
    CALL READ_SURF(HPROGRAM,YRECFM,LDATA_COP_RAT,IRESP)
    YRECFM='L_T_SIZE_MAX'
    CALL READ_SURF(HPROGRAM,YRECFM,LDATA_T_SIZE_MAX,IRESP)
    YRECFM='L_T_SIZE_MIN'
    CALL READ_SURF(HPROGRAM,YRECFM,LDATA_T_SIZE_MIN,IRESP)
  ENDIF
  !
ENDIF
!
!* read number of layers if thermal properties are specified
!
IF (LDATA_HC_ROOF) THEN
  YRECFM='PAR_RF_LAYER'
  IF (IVERSION<7 .OR. (IVERSION==7 .AND. IBUGFIX<=2)) YRECFM='ROOF_LAYER'
  CALL READ_SURF(HPROGRAM,YRECFM,NPAR_ROOF_LAYER,IRESP)
END IF
!
IF (LDATA_HC_ROAD) THEN
  YRECFM='PAR_RD_LAYER'
  IF (IVERSION<7 .OR. (IVERSION==7 .AND. IBUGFIX<=2)) YRECFM='ROAD_LAYER'
  CALL READ_SURF(HPROGRAM,YRECFM,NPAR_ROAD_LAYER,IRESP)
END IF
!
IF (LDATA_HC_WALL) THEN
  YRECFM='PAR_WL_LAYER'
  IF (IVERSION<7 .OR. (IVERSION==7 .AND. IBUGFIX<=2)) YRECFM='WALL_LAYER'
  CALL READ_SURF(HPROGRAM,YRECFM,NPAR_WALL_LAYER,IRESP)
END IF
!
IF (LDATA_HC_FLOOR) THEN
  YRECFM='PAR_FL_LAYER'
  IF (IVERSION<7 .OR. (IVERSION==7 .AND. IBUGFIX<=2)) YRECFM='FLOOR_LAYER'
  CALL READ_SURF(HPROGRAM,YRECFM,NPAR_FLOOR_LAYER,IRESP)
END IF
!
!* read specified fields
!
IF (LDATA_BLDTYPE .AND. .NOT. LDATA_BLDTYPE) THEN
  CALL ABOR1_SFX('FATAL ERROR: Building type is prescribed but not the building age')
END IF
!
IF (LDATA_BLDTYPE) THEN
  ALLOCATE(NPAR_BLDTYPE     (NDIM))    
  YRECFM='D_BLDTYPE'
  CALL READ_FIELD(YRECFM,ZWORK,HDIRIN)
  NPAR_BLDTYPE(:) = NINT(ZWORK)
ENDIF
!
IF (LDATA_BLD_AGE) THEN
  ALLOCATE(NPAR_BLD_AGE     (NDIM))    
  YRECFM='D_BLD_AGE'
  CALL READ_FIELD(YRECFM,ZWORK,HDIRIN)
  NPAR_BLD_AGE(:) = NINT(ZWORK)
ENDIF
!
IF (LDATA_BLDTYPE .AND. LDATA_BLDTYPE) THEN
  ALLOCATE(NPAR_BLDCODE(NDIM))
  NPAR_BLDCODE=BLDCODE(NPAR_BLDTYPE,NPAR_BLD_AGE)
END IF
!
IF (LDATA_USETYPE) THEN
  ALLOCATE(NPAR_USETYPE     (NDIM))    
  YRECFM='D_USETYPE'
  CALL READ_FIELD(YRECFM,ZWORK,HDIRIN)
  NPAR_USETYPE(:) = NINT(ZWORK)
ENDIF
!
IF (LDATA_Z0_TOWN) THEN
  ALLOCATE(XPAR_Z0_TOWN     (NDIM))
  YRECFM='D_Z0_TOWN'
  CALL READ_FIELD(YRECFM,XPAR_Z0_TOWN,HDIRIN)
ENDIF
!
IF (LDATA_BLD) THEN
  ALLOCATE(XPAR_BLD         (NDIM))
  YRECFM='D_BLD'
  CALL READ_FIELD(YRECFM,XPAR_BLD,HDIRIN)
ENDIF
!
IF (IVERSION>=6) THEN
  IF (LDATA_GARDEN) THEN
    ALLOCATE(XPAR_GARDEN      (NDIM))
    YRECFM='D_GARDEN'
    CALL READ_FIELD(YRECFM,XPAR_GARDEN,HDIRIN)
  ENDIF
!
ENDIF
!
IF (LDATA_GREENROOF) THEN
  ALLOCATE(XPAR_GREENROOF    (NDIM))
  YRECFM='D_GREENROOF'
  CALL READ_FIELD(YRECFM,XPAR_GREENROOF,HDIRIN)
ENDIF
!
IF (LDATA_ROAD_DIR) THEN
  ALLOCATE(XPAR_ROAD_DIR    (NDIM))
  YRECFM='D_ROAD_DIR'
  CALL READ_FIELD(YRECFM,XPAR_ROAD_DIR,HDIRIN)
ENDIF
!
IF (LDATA_ALB_ROOF) THEN
  ALLOCATE(XPAR_ALB_ROOF    (NDIM))        
  YRECFM='D_ALB_ROOF'
  CALL READ_FIELD(YRECFM,XPAR_ALB_ROOF,HDIRIN)
ENDIF
!
IF (LDATA_EMIS_ROOF) THEN
  ALLOCATE(XPAR_EMIS_ROOF   (NDIM))        
  YRECFM='D_EMI_ROOF'
  CALL READ_FIELD(YRECFM,XPAR_EMIS_ROOF,HDIRIN)
ENDIF
!
IF (LDATA_HC_ROOF) THEN
  ALLOCATE(XPAR_HC_ROOF     (NDIM,NPAR_ROOF_LAYER))
  DO JLAYER=1,NPAR_ROOF_LAYER
    WRITE(YRECFM,FMT='(A9,I1.1)') 'D_HC_ROOF',JLAYER
    CALL READ_FIELD(YRECFM,XPAR_HC_ROOF(:,JLAYER),HDIRIN)
  END DO
ENDIF
!
IF (LDATA_TC_ROOF) THEN
  ALLOCATE(XPAR_TC_ROOF     (NDIM,NPAR_ROOF_LAYER))
  DO JLAYER=1,NPAR_ROOF_LAYER
    WRITE(YRECFM,FMT='(A9,I1.1)') 'D_TC_ROOF',JLAYER
    CALL READ_FIELD(YRECFM,XPAR_TC_ROOF(:,JLAYER),HDIRIN)
  END DO
ENDIF
!
IF (LDATA_D_ROOF) THEN
  ALLOCATE(XPAR_D_ROOF      (NDIM,NPAR_ROOF_LAYER))
  DO JLAYER=1,NPAR_ROOF_LAYER
    WRITE(YRECFM,FMT='(A8,I1.1)') 'D_D_ROOF',JLAYER
    CALL READ_FIELD(YRECFM,XPAR_D_ROOF(:,JLAYER),HDIRIN)
  END DO
ENDIF
!
IF (LDATA_ALB_ROAD) THEN
  ALLOCATE(XPAR_ALB_ROAD    (NDIM))
  YRECFM='D_ALB_ROAD'
  CALL READ_FIELD(YRECFM,XPAR_ALB_ROAD,HDIRIN)
ENDIF
!
IF (LDATA_EMIS_ROAD) THEN
  ALLOCATE(XPAR_EMIS_ROAD   (NDIM))
  YRECFM='D_EMI_ROAD'
  CALL READ_FIELD(YRECFM,XPAR_EMIS_ROAD,HDIRIN)
ENDIF
!
IF (LDATA_HC_ROAD) THEN
  ALLOCATE(XPAR_HC_ROAD     (NDIM,NPAR_ROAD_LAYER))
  DO JLAYER=1,NPAR_ROAD_LAYER
    WRITE(YRECFM,FMT='(A9,I1.1)') 'D_HC_ROAD',JLAYER
    CALL READ_FIELD(YRECFM,XPAR_HC_ROAD(:,JLAYER),HDIRIN)
  END DO
ENDIF
!
IF (LDATA_TC_ROAD) THEN
  ALLOCATE(XPAR_TC_ROAD     (NDIM,NPAR_ROAD_LAYER))
  DO JLAYER=1,NPAR_ROAD_LAYER
    WRITE(YRECFM,FMT='(A9,I1.1)') 'D_TC_ROAD',JLAYER
    CALL READ_FIELD(YRECFM,XPAR_TC_ROAD(:,JLAYER),HDIRIN)
  END DO
ENDIF
!
IF (LDATA_D_ROAD) THEN
  ALLOCATE(XPAR_D_ROAD      (NDIM,NPAR_ROAD_LAYER))
  DO JLAYER=1,NPAR_ROAD_LAYER
    WRITE(YRECFM,FMT='(A8,I1.1)') 'D_D_ROAD',JLAYER
    CALL READ_FIELD(YRECFM,XPAR_D_ROAD(:,JLAYER),HDIRIN)
  END DO
ENDIF
!
IF (LDATA_ALB_WALL) THEN
  ALLOCATE(XPAR_ALB_WALL    (NDIM))
  YRECFM='D_ALB_WALL'
  CALL READ_FIELD(YRECFM,XPAR_ALB_WALL,HDIRIN)
ENDIF
!
IF (LDATA_EMIS_WALL) THEN
  ALLOCATE(XPAR_EMIS_WALL   (NDIM))
  YRECFM='D_EMI_WALL'
  CALL READ_FIELD(YRECFM,XPAR_EMIS_WALL,HDIRIN)
ENDIF
!
IF (LDATA_HC_WALL) THEN
  ALLOCATE(XPAR_HC_WALL     (NDIM,NPAR_WALL_LAYER))
  DO JLAYER=1,NPAR_WALL_LAYER
    WRITE(YRECFM,FMT='(A9,I1.1)') 'D_HC_WALL',JLAYER
    CALL READ_FIELD(YRECFM,XPAR_HC_WALL(:,JLAYER),HDIRIN)
  END DO
ENDIF
!
IF (LDATA_TC_WALL) THEN
  ALLOCATE(XPAR_TC_WALL     (NDIM,NPAR_WALL_LAYER))
  DO JLAYER=1,NPAR_WALL_LAYER
    WRITE(YRECFM,FMT='(A9,I1.1)') 'D_TC_WALL',JLAYER
    CALL READ_FIELD(YRECFM,XPAR_TC_WALL(:,JLAYER),HDIRIN)
  END DO
ENDIF
!
IF (LDATA_D_WALL) THEN
  ALLOCATE(XPAR_D_WALL      (NDIM,NPAR_WALL_LAYER))
  DO JLAYER=1,NPAR_WALL_LAYER
    WRITE(YRECFM,FMT='(A8,I1.1)') 'D_D_WALL',JLAYER
    CALL READ_FIELD(YRECFM,XPAR_D_WALL(:,JLAYER),HDIRIN)
  END DO
ENDIF
!
IF (LDATA_BLD_HEIGHT) THEN
  ALLOCATE(XPAR_BLD_HEIGHT  (NDIM))
  YRECFM='D_BLD_HEIG'
  CALL READ_FIELD(YRECFM,XPAR_BLD_HEIGHT,HDIRIN)
ENDIF
!
IF (LDATA_WALL_O_HOR) THEN
  ALLOCATE(XPAR_WALL_O_HOR  (NDIM))
  YRECFM='D_WALL_O_H'
  CALL READ_FIELD(YRECFM,XPAR_WALL_O_HOR,HDIRIN)
ENDIF
!
IF (LDATA_H_TRAFFIC) THEN
  ALLOCATE(XPAR_H_TRAFFIC   (NDIM))
  YRECFM='D_H_TRAF'
  CALL READ_FIELD(YRECFM,XPAR_H_TRAFFIC,HDIRIN)
ENDIF
!
IF (LDATA_LE_TRAFFIC) THEN
  ALLOCATE(XPAR_LE_TRAFFIC  (NDIM))
  YRECFM='D_LE_TRAF'
  CALL READ_FIELD(YRECFM,XPAR_LE_TRAFFIC,HDIRIN)
ENDIF
!
IF (LDATA_H_INDUSTRY) THEN
  ALLOCATE(XPAR_H_INDUSTRY  (NDIM))
  YRECFM='D_H_IND'
  CALL READ_FIELD(YRECFM,XPAR_H_INDUSTRY,HDIRIN)
ENDIF
!
IF (LDATA_LE_INDUSTRY) THEN
  ALLOCATE(XPAR_LE_INDUSTRY (NDIM))
  YRECFM='D_LE_IND'
  CALL READ_FIELD(YRECFM,XPAR_LE_INDUSTRY,HDIRIN)
ENDIF
!
IF (LDATA_ROUGH_ROOF) THEN
  ALLOCATE(XPAR_ROUGH_ROOF (NDIM))
  YRECFM='D_ROUGH_ROOF'
  CALL READ_FIELD(YRECFM,XPAR_ROUGH_ROOF,HDIRIN)
ENDIF
!
IF (LDATA_ROUGH_WALL) THEN
  ALLOCATE(XPAR_ROUGH_WALL (NDIM))
  YRECFM='D_ROUGH_WALL'
  CALL READ_FIELD(YRECFM,XPAR_ROUGH_WALL,HDIRIN)
ENDIF
!
IF (CBEM=='BEM') THEN
  !

  IF (LDATA_HC_FLOOR) THEN
    ALLOCATE(XPAR_HC_FLOOR    (NDIM,NPAR_FLOOR_LAYER))
    DO JLAYER=1,NPAR_FLOOR_LAYER
      WRITE(YRECFM,FMT='(A10,I1.1)') 'D_HC_FLOOR',JLAYER
      CALL READ_FIELD(YRECFM,XPAR_HC_FLOOR(:,JLAYER),HDIRIN)
    END DO
  ENDIF
  !
  IF (LDATA_TC_FLOOR) THEN
    ALLOCATE(XPAR_TC_FLOOR    (NDIM,NPAR_FLOOR_LAYER))
    DO JLAYER=1,NPAR_FLOOR_LAYER
      WRITE(YRECFM,FMT='(A10,I1.1)') 'D_TC_FLOOR',JLAYER
      CALL READ_FIELD(YRECFM,XPAR_TC_FLOOR(:,JLAYER),HDIRIN)
    END DO
  ENDIF
  !
  IF (LDATA_D_FLOOR) THEN
    ALLOCATE(XPAR_D_FLOOR     (NDIM,NPAR_FLOOR_LAYER))
    DO JLAYER=1,NPAR_FLOOR_LAYER
      WRITE(YRECFM,FMT='(A9,I1.1)') 'D_D_FLOOR',JLAYER
      CALL READ_FIELD(YRECFM,XPAR_D_FLOOR(:,JLAYER),HDIRIN)
    END DO
  ENDIF
  !
  IF (LDATA_TCOOL_TARGET) THEN
    ALLOCATE(XPAR_TCOOL_TARGET  (NDIM))
    YRECFM='D_TCOOL_TARG'
    CALL READ_FIELD(YRECFM,XPAR_TCOOL_TARGET,HDIRIN)
  ENDIF
  !
  IF (LDATA_THEAT_TARGET) THEN
    ALLOCATE(XPAR_THEAT_TARGET  (NDIM))
    YRECFM='D_THEAT_TARG'
    CALL READ_FIELD(YRECFM,XPAR_THEAT_TARGET,HDIRIN)
  ENDIF
  !
  IF (LDATA_F_WASTE_CAN) THEN
    ALLOCATE(XPAR_F_WASTE_CAN   (NDIM))
    YRECFM='D_F_WAST_CAN'
    CALL READ_FIELD(YRECFM,XPAR_F_WASTE_CAN,HDIRIN)
  ENDIF
  !
  IF (LDATA_EFF_HEAT) THEN
    ALLOCATE(XPAR_EFF_HEAT      (NDIM))
    YRECFM='D_EFF_HEAT'
    CALL READ_FIELD(YRECFM,XPAR_EFF_HEAT,HDIRIN)
  ENDIF
  !
  IF (LDATA_QIN) THEN
    ALLOCATE(XPAR_QIN           (NDIM))
    YRECFM='D_QIN'
    CALL READ_FIELD(YRECFM,XPAR_QIN,HDIRIN)
  ENDIF
  !
  IF (LDATA_QIN_FRAD) THEN
    ALLOCATE(XPAR_QIN_FRAD      (NDIM))
    YRECFM='D_QIN_FRAD'
    CALL READ_FIELD(YRECFM,XPAR_QIN_FRAD,HDIRIN)
  ENDIF
  !
  IF (LDATA_SHGC) THEN
    ALLOCATE(XPAR_SHGC          (NDIM))
    YRECFM='D_SHGC'
    CALL READ_FIELD(YRECFM,XPAR_SHGC,HDIRIN)
  ENDIF
  !
  IF (LDATA_U_WIN) THEN
    ALLOCATE(XPAR_U_WIN         (NDIM))
    YRECFM='D_U_WIN'
    CALL READ_FIELD(YRECFM,XPAR_U_WIN,HDIRIN)
  ENDIF
  !
  IF (LDATA_GR) THEN
    ALLOCATE(XPAR_GR            (NDIM))
    YRECFM='D_GR'
    CALL READ_FIELD(YRECFM,XPAR_GR,HDIRIN)
  ENDIF
  !
  IF (LDATA_SHGC_SH) THEN
    ALLOCATE(XPAR_SHGC_SH       (NDIM))
    YRECFM='D_SHGC_SH'
    CALL READ_FIELD(YRECFM,XPAR_SHGC_SH,HDIRIN)
  ENDIF
  !
  IF (LDATA_FLOOR_HEIGHT) THEN
    ALLOCATE(XPAR_FLOOR_HEIGHT  (NDIM))
    YRECFM='D_FLOOR_HEIG'
    CALL READ_FIELD(YRECFM,XPAR_FLOOR_HEIGHT,HDIRIN)
  ENDIF
  !
  IF (LDATA_INF) THEN
    ALLOCATE(XPAR_INF           (NDIM))
    YRECFM='D_INF'
    CALL READ_FIELD(YRECFM,XPAR_INF,HDIRIN)
  ENDIF
  !
  IF (LDATA_F_WATER_COND) THEN
     ALLOCATE(XPAR_F_WATER_COND (NDIM))
    YRECFM='D_FWAT_COND'
    CALL READ_FIELD(YRECFM,XPAR_F_WATER_COND,HDIRIN)
  ENDIF
  !
  IF (LDATA_SHADE) THEN
    ALLOCATE(XPAR_SHADE        (NDIM))
    YRECFM='D_SHADE'
    CALL READ_FIELD(YRECFM,XPAR_SHADE,HDIRIN)
    XPAR_SHADE=FLOAT(NINT(XPAR_SHADE))
  ENDIF
  !
  IF (LDATA_NATVENT) THEN
    ALLOCATE(XPAR_NATVENT      (NDIM))
    YRECFM='D_NATVENT'
    CALL READ_FIELD(YRECFM,XPAR_NATVENT,HDIRIN)
    XPAR_NATVENT=FLOAT(NINT(XPAR_NATVENT))
  ENDIF
  !  
  IF (LDATA_QIN_FLAT) THEN
    ALLOCATE(XPAR_QIN_FLAT     (NDIM))
    YRECFM='D_QIN_FLAT'
    CALL READ_FIELD(YRECFM,XPAR_QIN_FLAT,HDIRIN)
  ENDIF
  !
  IF (LDATA_HR_TARGET) THEN
    ALLOCATE(XPAR_HR_TARGET    (NDIM))
    YRECFM='D_HR_TARGET'
    CALL READ_FIELD(YRECFM,XPAR_HR_TARGET,HDIRIN)
  ENDIF
  !
  IF (LDATA_V_VENT) THEN
    ALLOCATE(XPAR_V_VENT       (NDIM))
    YRECFM='D_V_VENT'
    CALL READ_FIELD(YRECFM,XPAR_V_VENT,HDIRIN)
  ENDIF
  !
  IF (LDATA_CAP_SYS_HEAT) THEN
    ALLOCATE(XPAR_CAP_SYS_HEAT (NDIM))
    YRECFM='D_CAP_SYS_HE'
    CALL READ_FIELD(YRECFM,XPAR_CAP_SYS_HEAT,HDIRIN)
  ENDIF
  !
  IF (LDATA_CAP_SYS_RAT) THEN
    ALLOCATE(XPAR_CAP_SYS_RAT  (NDIM))
    YRECFM='D_CAP_SYS_RA'
    CALL READ_FIELD(YRECFM,XPAR_CAP_SYS_RAT,HDIRIN)
  ENDIF
  !
  IF (LDATA_T_ADP) THEN
    ALLOCATE(XPAR_T_ADP        (NDIM))
    YRECFM='D_T_ADP'
    CALL READ_FIELD(YRECFM,XPAR_T_ADP,HDIRIN)
  ENDIF
  !
  IF (LDATA_M_SYS_RAT) THEN
    ALLOCATE(XPAR_M_SYS_RAT    (NDIM))
    YRECFM='D_M_SYS_RAT'
    CALL READ_FIELD(YRECFM,XPAR_M_SYS_RAT,HDIRIN)
  ENDIF
  !
  IF (LDATA_COP_RAT) THEN
    ALLOCATE(XPAR_COP_RAT      (NDIM))
    YRECFM='D_COP_RAT'
    CALL READ_FIELD(YRECFM,XPAR_COP_RAT,HDIRIN)
  ENDIF
  !
  IF (LDATA_T_SIZE_MAX) THEN
    ALLOCATE(XPAR_T_SIZE_MAX   (NDIM))
    YRECFM='D_T_SIZE_MAX'
    CALL READ_FIELD(YRECFM,XPAR_T_SIZE_MAX,HDIRIN)
  ENDIF
  !
  IF (LDATA_T_SIZE_MIN) THEN
    ALLOCATE(XPAR_T_SIZE_MIN   (NDIM))
    YRECFM='D_T_SIZE_MIN'
    CALL READ_FIELD(YRECFM,XPAR_T_SIZE_MIN,HDIRIN)
  ENDIF
  !
ENDIF
!
IF (LHOOK) CALL DR_HOOK('READ_PGD_TEB_PAR_N',1,ZHOOK_HANDLE)
!
!-------------------------------------------------------------------------------
CONTAINS
!-------------------------------------------------------------------------------
!
SUBROUTINE READ_FIELD(HRECFM,PFIELD,YDIR)
!
USE MODI_HOR_INTERPOL
!
IMPLICIT NONE
!
 CHARACTER(LEN=*),     INTENT(IN)  :: HRECFM ! name of record in the file
REAL, DIMENSION(NDIM), INTENT(OUT) :: PFIELD
 CHARACTER(LEN=1),     INTENT(IN)  :: YDIR
!
REAL, DIMENSION(KNI)              :: ZF
REAL, DIMENSION(:,:), POINTER     :: ZIN
REAL, DIMENSION(NDIM,1)           :: ZOUT
REAL(KIND=JPRB) :: ZHOOK_HANDLE
!
IF (LHOOK) CALL DR_HOOK('READ_PGD_TEB_PAR_N:READ_FIELD',0,ZHOOK_HANDLE)
!
IF (YDIR=='A') THEN
  !
  CALL READ_SURF(HPROGRAM,HRECFM,ZF,IRESP,HDIR='A')
  ALLOCATE(ZIN(KNI,1))
  ZIN(:,1) = ZF(:)
  CALL HOR_INTERPOL(ILUOUT,ZIN,ZOUT)
  DEALLOCATE(ZIN)
  PFIELD(:) = ZOUT(:,1)
  !
ELSE
  CALL READ_SURF(HPROGRAM,HRECFM,PFIELD,IRESP)
ENDIF
!
IF (LHOOK) CALL DR_HOOK('READ_PGD_TEB_PAR_N:READ_FIELD',1,ZHOOK_HANDLE)
!
END SUBROUTINE READ_FIELD
!_______________________________
!
END SUBROUTINE READ_PGD_TEB_PAR_n
